package com.example.bug;

import java.io.OutputStream;

import org.apache.commons.io.IOUtils;
import org.docx4j.convert.in.xhtml.XHTMLImporterImpl;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class DocxTemplateAdapter implements TemplateAdapter {
	private static final Logger LOGGER = LoggerFactory.getLogger(DocxTemplateAdapter.class);

	public void generate(OutputStream os) {
        try {
            String xhtml = IOUtils.toString(Thread.currentThread().getContextClassLoader().getResourceAsStream(TEMPLATE));
            WordprocessingMLPackage doc = WordprocessingMLPackage.createPackage();

            XHTMLImporterImpl xhtmlImporter = new XHTMLImporterImpl(doc);
            xhtmlImporter.setHyperlinkStyle("Hyperlink");
            LOGGER.debug("using {} as base url", System.getProperty("user.dir"));
            doc.getMainDocumentPart().getContent().addAll(xhtmlImporter.convert(xhtml, "file://"));

            doc.save(os);
            os.flush();

        } catch (Exception e) {
        	LOGGER.error("I should really do somethign with this error but this is just example code so...",e);
        } finally {
        }
        return;
		
	}

}
