/**
 * 
 */
package com.example.bug.url.protocols.classpath;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This Handler handles resolving a the classpath: urls for tests.  
 * We do not support this for production use.
 */
public class Handler extends URLStreamHandler {
	private static final Logger LOGGER = LoggerFactory.getLogger(Handler.class);

    @Override
    protected URLConnection openConnection(final URL u) throws IOException {
    	LOGGER.debug("Url {} path {}", u.toString(), u.getPath());
        final URL resourceUrl = Thread.currentThread().getContextClassLoader().getSystemClassLoader().getResource(u.getPath());
        return resourceUrl.openConnection();
    }
}